import numpy as np
import matplotlib.pyplot as plt
from scipy import stats


global_index_figure = 0

def float_list(l): # convert a list of char in a list of float 
    L = []
    for i in l:
        L.append(float(i))
    return(L)

def product_list(L,x, b = 0): # linear convertion of a list return L*x + b (b is 0 as default) 
    Lx = []
    for i in L:
        Lx.append(i*x +b)
    return(Lx)

def read_data_xmotor_ymotor_Va_Vb_Vc_Vd_sum_x_y(fichier): # program to read data from a file of data with position of motor and them Va, Vb, Vc and Vd
    fichier = open(fichier, "r")
    Data = fichier.read()
    Data_list = [[[] for i in range(9)] for j in range(3)]
    value = ""
    index = 0
    for i in Data:
        if (i == " ") :
            if index == -1: 
                bpm_index = int(value)
                Data_list[0].append(value)
                index +=1
            elif index == 1:
                Data_list[1].append(value)
                #print(value)
                index += 1
            elif index == 2:
                Data_list[2].append(value)
                index += 1
            elif index == 3:
                Data_list[3].append(value)
                index += 1
            else:
                Data_list[4].append(value)
                index = 0
            value = ""
        elif (i == "\n") :
            value = ""
            index = -1
        else:
            value += i
    fichier.close()
    for i in range(5):
        Data_list[i] = float_list(Data_list[i])
    Data_list[0] = product_list(Data_list[0],10**-6)
    for i in range(1,5):
        Data_list[i] = product_list(Data_list[i],1000)
    return(Data_list)



def read_data_position_Va_Vb_Vc_Vd(fichier): # program to read data from a file of data with position of motor and them Va, Vb, Vc and Vd
    fichier = open(fichier, "r")
    Data = fichier.read()
    Data_list = [[],[],[],[],[]]
    value = ""
    index = 0
    for i in Data:
        if (i == " ") :
            if index == 0: 
                Data_list[0].append(value)
                index +=1
            elif index == 1:
                Data_list[1].append(value)
                #print(value)
                index += 1
            elif index == 2:
                Data_list[2].append(value)
                index += 1
            elif index == 3:
                Data_list[3].append(value)
                index += 1
            else:
                Data_list[4].append(value)
                index = 0
            value = ""
        elif (i == "\n") :
            value = ""
        else:
            value += i
    fichier.close()
    for i in range(5):
        Data_list[i] = float_list(Data_list[i])
    Data_list[0] = product_list(Data_list[0],10**-6)
    for i in range(1,5):
        Data_list[i] = product_list(Data_list[i],1000)
    return(Data_list)





def print_graph(L): # program to print graph of X_libera vs X_motor with a list L = [[[x_motor_position][y_motor_position][Va][Vb][Vc][Vd][sum][x_libera_position][y_libera_position]][same for BPM1][same for BPM2]], also do a linear regretion and print the equation
    global global_index_figure # to creat different figure
    fig1 = plt.figure(global_index_figure)
    global_index_figure += 1
    plt.clf()
    for bpm_data in range(L):
        lr1 = stats.linregress(bpm_data[0],bpm_data[7]) # return tuple (pente,ordonnee a l'origine, coef de correlation, p-value, erreur standard de l'estimation)
        plt.plot(bpm_data[0],bpm_data[7], "r", label = "BMP_ref")
        plt.plot(bpm_data[0],[lr1.slope*i + lr1.intercept for i in bpm_data[0]], "r--", label = "BMP_ref regression line, \nerror = "+str(round(lr1.stderr,3))+",\ncorrelation coefficient = "+str(round(lr1.rvalue,3)))







    """
    lr1 = stats.linregress(L[1],L[1]) # return tuple (pente,ordonnee a l'origine, coef de correlation, p-value, erreur standard de l'estimation)
    plt.plot(L[0],L[1], "r", label = "BMP_ref")
    plt.plot(L[0],[lr1.slope*i + lr1.intercept for i in L[0]], "r--", label = "BMP_ref regression line, \nerror = "+str(round(lr1.stderr,3))+",\ncorrelation coefficient = "+str(round(lr1.rvalue,3)))

    lr2 = stats.linregress(L[0],L[2])
    plt.plot(L[0],L[2], "b", label = "BMP_impr")
    plt.plot(L[0],[lr2.slope*i + lr2.intercept for i in L[0]], "b--", label = "BMP_impr regression line, \nerror = "+str(round(lr2.stderr,3))+",\ncorrelation coefficient = "+str(round(lr2.rvalue,3)))

    lr3 = stats.linregress(L[0],L[3])
    plt.plot(L[0],L[3], "g", label = "BMP_ref")
    plt.plot(L[0],[lr3.slope*i + lr3.intercept for i in L[0]], "g--", label = "BMP_ref regression line, \nerror = "+str(round(lr3.stderr,3))+",\ncorrelation coefficient = "+str(round(lr3.rvalue,3)))

    lr4 = stats.linregress(L[0],L[4])
    plt.plot(L[0],L[4], "m", label = "BMP_impr")
    plt.plot(L[0],[lr4.slope*i + lr4.intercept for i in L[0]], "m--", label = "BMP_impr regression line, \nerror = "+str(round(lr4.stderr,2))+",\ncorrelation coefficient = "+str(round(lr4.rvalue,3)))
    
    plt.legend()
    plt.xlabel("length in million motor step") #, fontsize=20)
    plt.ylabel("tension in mV")
    plt.gca().yaxis.set_tick_params(labelsize = 8)
#    plt.show()
"""
def residu_position_Va_Vb_Vc_Vd(L): # program to do graph of residu of data give in a list with [[position][Va][Vb][Vc][Vd]]
    global global_index_figure
    fig1 = plt.figure(global_index_figure)
    global_index_figure += 1
    plt.clf()
    plt.title("Residu")
    lr1 = stats.linregress(L[0],L[1]) # return tuple (pente (.slope),ordonnee a l'origine (.intercept), coef de correlation (.rvalue), p-value (.pvalue ?), erreur standard de l'estimation (.stderr))
    for i in range(len(L[1])):
        L[1][i] = L[1][i] -  lr1.slope*L[0][i] - lr1.intercept
    plt.plot(L[0],L[1], "r", label = "BMP_ref")

    lr2 = stats.linregress(L[0],L[2])
    for i in range(len(L[2])):
        L[2][i] = L[2][i] -  lr2.slope*L[0][i] - lr2.intercept
    plt.plot(L[0],L[2], "b", label = "BMP_impr")

    lr3 = stats.linregress(L[0],L[3])
    for i in range(len(L[3])):
        L[3][i] = L[3][i] -  lr3.slope*L[0][i] - lr3.intercept
    plt.plot(L[0],L[3], "g", label = "BMP_ref")

    lr4 = stats.linregress(L[0],L[4])
    for i in range(len(L[4])):
        L[4][i] = L[4][i] -  lr4.slope*L[0][i] - lr4.intercept
    plt.plot(L[0],L[4], "m", label = "BMP_impr")
    plt.legend()
    plt.xlabel("length in million motor step")
    plt.ylabel("tension in mV")
#    plt.show()
    
"""    
    ax2 = fig.add_axes((0.1,0.1,0.8,0.0))
    ax2.yaxis.set_visible(False) # hide the yaxis
    ax2.set_xticklabels(10*L[0])
    ax2.set_xlabel("lenght in mm")
    plt.show()
"""

def min_max(L,mini = None ,maxi = None): #program to cut a list L = [[position][Va][Vb][Vc][Vd]] with minimum value of position = mini and maximum value of position = maxi 
    if mini is None :
        mini = L[0][0]
    if maxi is None :
        maxi = L[0][len(L[0])-1]
    if mini > maxi:
        mini,maxi = maxi,mini
    index_list = []
    for i in range(len(L[0])):
        if  L[0][i] >= mini and L[0][i] <= maxi :
            index_list.append(i)
    return([[L[0][i] for i in index_list],[L[1][i] for i in index_list],[L[2][i] for i in index_list],[L[3][i] for i in index_list],[L[4][i] for i in index_list]])


def convertion_step_mm(L,begin_mm,end_mm): # length convertion 
    begin_step = L[0]
    end_step = L[len(L)-1]
    a = float((end_mm - begin_mm))/(end_step - begin_step)
    b = begin_mm - a*begin_step
    print(a,b)
    print(L)
    L = product_list(L, a, b)
    return(L)
    

#L = [[i for i in range(51)] for j in range(5)]
#print(convertion_step_mm(L[0],3.1,44520))

    
def print_data_position_Va_Vb_Vc_Vd(fichier, min = None, max = None):
    L = min_max(read_data_position_Va_Vb_Vc_Vd(fichier), mini = min, maxi = max)
    print_graph(L)
    #print(L)

def print_residu_position_Va_Vb_Vc_Vd(fichier, min = None, max = None):
    L = min_max(read_data_position_Va_Vb_Vc_Vd(fichier), mini = min, maxi = max)
    residu_position_Va_Vb_Vc_Vd(L)

print_data_position_Va_Vb_Vc_Vd("data/position_vs_tension_ch1-3_bpm_ref_ch2-4_bpm_impr_20180611_160153_0.txt",0.1,0.3)
print_residu_position_Va_Vb_Vc_Vd("data/position_vs_tension_ch1-3_bpm_ref_ch2-4_bpm_impr_20180611_160153_0.txt",0.1,0.3)

#print_data_position_Va_Vb_Vc_Vd("data/position_vs_tension_ch1-3_bpm_ref_ch2-4_bpm_impr_20180611_163036_0.txt")

#print_data_position_Va_Vb_Vc_Vd("data/position_vs_tension_ch1-3_bpm_ref_ch2-4_bpm_impr_vertical_acquisition_20180612_0.txt")
#print_data_position_Va_Vb_Vc_Vd("data/position_vs_tension_ch1-3_bpm_ref_ch2-4_bpm_impr_vertical_acquisition_20180612_0.txt")
plt.show()

